#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
import urllib,re,os
import xbmcplugin,xbmcgui
import xbmcaddon,xbmc
import xbmcvfs
import requests
import urlparse

addon = xbmcaddon.Addon(id='plugin.video.moviesever')
home = addon.getAddonInfo('path').decode('utf-8')
image = xbmc.translatePath(os.path.join(home, 'icon.png'))
base_url = 'http://moviesever.com'
headers = {'User-Agent':'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/29.0.1547.57 Safari/537.36'}
    
pluginhandle = int(sys.argv[1])

def list_categories():
    addDir('Neue Filme',base_url,'list_movies',image)
    addDir('Alle Filme',base_url,'list_movies',image)
    genres = get_genres()
    for genre in genres:
        url = genre['url']
        name = genre['genre']
        addDir(name,url,'list_movies',image)
    xbmcplugin.endOfDirectory(pluginhandle)

def get_genres():
    # _genres = []
    # try:
        # content = requests.get(base_url, headers=headers).content
        # match = re.findall('<h2>Kategorien</h2>(.*?)<div class="footborder"></div>', content, re.DOTALL)
        # genres = re.findall('<a href="(.*?)" >(.*?)</a>', match[0])
        # for url, genre in genres:
            # _genres.append({'url': url, 'genre': genre})
        # print _genres
    # except:
    #     pass
    _genres = ({'url': 'http://moviesever.com/category/3d/', 'genre': '3D'}, {'url': 'http://moviesever.com/category/action/', 'genre': 'Action'}, {'url': 'http://moviesever.com/category/adventure/', 'genre': 'Adventure'}, {'url': 'http://moviesever.com/category/animation/', 'genre': 'Animation'}, {'url': 'http://moviesever.com/category/biography/', 'genre': 'Biography'}, {'url': 'http://moviesever.com/category/comedy/', 'genre': 'Comedy'}, {'url': 'http://moviesever.com/category/crime/', 'genre': 'Crime'}, {'url': 'http://moviesever.com/category/drama/', 'genre': 'Drama'}, {'url': 'http://moviesever.com/category/family/', 'genre': 'Family'}, {'url': 'http://moviesever.com/category/fantasy/', 'genre': 'Fantasy'}, {'url': 'http://moviesever.com/category/horror/', 'genre': 'Horror'}, {'url': 'http://moviesever.com/category/imdb-9-0/', 'genre': 'IMDB 9.0+'}, {'url': 'http://moviesever.com/category/mystery/', 'genre': 'Mystery'}, {'url': 'http://moviesever.com/category/romance/', 'genre': 'Romance'}, {'url': 'http://moviesever.com/category/sci-fi/', 'genre': 'Sci-Fi'}, {'url': 'http://moviesever.com/category/thriler/', 'genre': 'Thriller'}, {'url': 'http://moviesever.com/category/war/', 'genre': 'War'}, {'url': 'http://moviesever.com/category/western/', 'genre': 'Western'})
    return _genres

def list_movies():
    url = args['url'][0]
    movies_list = get_movies_list(url)
    for movie in movies_list:
        url = movie['url']
        name = movie['name']
        name = name.replace('–','-')
        image = movie['image']
        cm = []
        library_uri = build_url({'name': name, 'url': url, 'mode': 'add_to_library'})
        cm.append( ('Add To Library', "XBMC.RunPlugin(%s)" % library_uri) )
        addLink(name,url,'play',image,cm)
    if not args['name'][0] == 'Neue Filme':
        xbmcplugin.addSortMethod(pluginhandle, xbmcplugin.SORT_METHOD_TITLE)
    xbmcplugin.endOfDirectory(pluginhandle)

def get_movies_list(url):
    movies_list = []
    if args['name'][0] == 'Neue Filme':
        pages = '1'
    else:
        try:
            content = requests.get(url, headers=headers).content
            pages = re.findall("<span class='pages'>Seite 1 von (\d+)</span>", content,)[0]
        except:
            pages = '1'
    for i in range(1, int(pages)+1):
        get_movies(url, i, movies_list)
    return movies_list

def get_movies(url, i, movies_list):
    try:
        url = url+'/page/'+str(i)
        content = requests.get(url, headers=headers).content
        movies = re.findall('<div class="moviefilm">(.*?)</div>', content, re.DOTALL)
        for movie in movies:
            match = re.findall('<a href="(.*?)".*?<img src="(.*?)" alt="(.*?)"', movie, re.DOTALL)
            for url, image, name in match:
                name = name.replace('&#8211;', '-').replace("&#8217;","'")
                movies_list.append({'url': url, 'name': name, 'image': image})
        return movies_list
    except:
        pass

def play():
    url = args['url'][0]
    hoster_list = get_hoster_list(url)
    file = get_file(hoster_list)
    if file:
        listitem = xbmcgui.ListItem(path=file)
        try:
            subtitle = addon.getSetting('subtitle')
            if subtitle:
                listitem.setSubtitles([subtitle])
        except:
            xbmc.executebuiltin('Notification(Kodi Required For Subtitles,)')
        xbmcplugin.setResolvedUrl(pluginhandle, True, listitem)
    else:
        xbmc.executebuiltin('Notification(No Stream Found,)')
    
def get_hoster_list(url):
    hoster_list = []
    try:
        addon.setSetting('subtitle', '')
        content = requests.get(url).content
        p = re.findall('<div class="keremiya_part">(.*?)</div>', content, re.DOTALL)
        if p:
            h = re.findall('<a href="(http.*?)">', p[0], re.DOTALL)
        else:
            h = None
        try:
            url = None
            hoster = get_hoster(url,content)
            hoster_list.append(hoster)
        except:
            pass
        if h:
            for url in h:
                try:
                    content = None
                    hoster = get_hoster(url,content)
                    hoster_list.append(hoster)
                except:
                    pass
        import random
        random.shuffle(hoster_list)
    except:
        pass
    return hoster_list
    
def get_hoster(url,content):
    if url: content = requests.get(url).content
    match = re.findall('<div class="filmicerik">(.*?)</div>', content, re.DOTALL)
    hoster = re.findall('<iframe.+?src="(.*?)"', match[0], re.DOTALL)
    try:
        subtitle = re.findall('file="(http.*?srt)"', match[0], re.DOTALL)
        addon.setSetting('subtitle', subtitle[0])
    except:
        pass
    return hoster[0]
        
def get_file(hoster_list):
    file = None
    for hoster in hoster_list:
        if not file:
            try:
                file = stream2k(hoster)
            except:
                pass
    return file
        
def stream2k(url):
    quality = addon.getSetting('quality')
    headers = {'referer': base_url}
    content = requests.get(url, headers=headers).content
    list = []
    files = re.findall('(?:"file"|file):"(.*?)".*?(?:"label"|label):"(\d+)', content)
    for file, label in files:
        if quality == label:
            break
        else:
            list.append({'file': file, 'label': label})
    try:
        if not label == quality:
            sorted_list = sort_by_quality(list)
            file = sorted_list[0]['file']
    except:
        pass
    if file:
        file = file.replace('\\','')
        return file

def sort_by_quality(list):
    sorted_list = []
    res = ['1080', '720', '480']
    for q in res:
        for e in list:
            if e['label'] == q:
                sorted_list.append(e)
    return sorted_list
    
def add_to_library():
    url = args['url'][0]
    name = args['name'][0]
    movies_path = addon.getSetting('movies_path')
    if movies_path:
        moviename = deumlaut((''.join(c for c in unicode(str(name), 'utf-8') if c not in '/\\:?"*|<>')).strip(' .'))
        strmentry = build_url({'mode': 'play', 'name': name, 'url': url})
        strm = os.path.join(movies_path, moviename, 'movie.strm')
        strm = xbmc.makeLegalFilename(strm)
        if not xbmcvfs.exists(os.path.dirname(strm)):
            try: 
                xbmcvfs.mkdirs(os.path.dirname(strm))
            except:
                xbmc.executebuiltin('Notification(Info: Konnte keinen Ordner erstellen!,)')
                return
        old_strmentry = ''
        try:
            f = xbmcvfs.File(strm, 'r')
            old_strmentry = f.read()
            f.close()
        except:
            pass
        if strmentry != old_strmentry:
            try:
                file_desc = xbmcvfs.File(strm, 'w')
                file_desc.write(strmentry)
                file_desc.close()
                xbmc.sleep(100)
                xbmc.executebuiltin('UpdateLibrary(video)')
            except:
                xbmc.executebuiltin('Notification(Info: Konnte keine Datei erstellen!,)')
    else:
        addon.openSettings()

def deumlaut(s):
    s = s.encode('utf-8')
    s = s.replace('ß', 'ss')
    s = s.replace('ü', 'ue')
    s = s.replace('Ü', 'Ue')
    s = s.replace('ö', 'oe')
    s = s.replace('Ö', 'Oe')
    s = s.replace('ä', 'ae')
    s = s.replace('Ä', 'Ae')
    return s
        
def addLink(name,url,mode,iconimage,cm):
    u = build_url({'mode': mode, 'name': name, 'url': url})
    item=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
    item.setInfo( type="Video", infoLabels={ "Title": name } )
    item.setProperty('IsPlayable', 'true')
    if cm: item.addContextMenuItems( cm )
    xbmcplugin.addDirectoryItem(pluginhandle,url=u,listitem=item)

def addDir(name,url,mode,iconimage):
    u = build_url({'mode': mode, 'name': name, 'url': url, 'iconimage': iconimage})
    item=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
    item.setInfo( type="Video", infoLabels={ "Title": name } )
    xbmcplugin.addDirectoryItem(pluginhandle,url=u,listitem=item,isFolder=True)

def build_url(query):
	return sys.argv[0] + '?' + urllib.urlencode(query)

args = urlparse.parse_qs(sys.argv[2][1:])
mode = args.get('mode', None)
print 'Arguments: '+str(args)

if mode==None:
    list_categories()
else:
    exec '%s()' % mode[0]